<?php

require_once( '../../internals/Header.inc.php' );

app_Finance::LogPayment( 'TIME: '.date("Y-m-d H:i:s", time())."; \n".print_r($_REQUEST, true), __FILE__, __LINE__ );

define('CREDIT_TYPE_CHARGEBACK', 2);

$merchant_fields = app_Finance::getPaymentProviderFields("Z-Payment");
$shop_id = $merchant_fields['shop_id'];
$merch_key = $merchant_fields['merchant_key'];
$err=false;
$LMI_PREREQUEST = $_REQUEST['LMI_PREREQUEST'];

if($LMI_PREREQUEST==1) {
    die('YES');
}



$custom = trim($_REQUEST['custom']);
$LMI_PAYMENT_NO = $_REQUEST['LMI_PAYMENT_NO'];
$LMI_PAYEE_PURSE = $_REQUEST['LMI_PAYEE_PURSE'];
$LMI_PAYMENT_AMOUNT = $_REQUEST['LMI_PAYMENT_AMOUNT'];
$LMI_MODE = $_REQUEST['LMI_MODE'];
$LMI_SYS_INVS_NO = $_REQUEST['LMI_SYS_INVS_NO'];
$LMI_SYS_TRANS_NO = $_REQUEST['LMI_SYS_TRANS_NO'];
$LMI_SYS_TRANS_DATE = $_REQUEST['LMI_SYS_TRANS_DATE'];
$LMI_PAYER_PURSE = $_REQUEST['LMI_PAYER_PURSE'];
$LMI_PAYER_WM = $_REQUEST['LMI_PAYER_WM'];

if ($shop_id!=$LMI_PAYEE_PURSE) {
    $err = TRUE;
	$errText = 'shop id mismatch';
}

if(isset($_REQUEST["LMI_SECRET_KEY"])){
	$LMI_SECRET_KEY=$_REQUEST["LMI_SECRET_KEY"];
	if($LMI_SECRET_KEY!=$merch_key) { 
	    $err = TRUE;
		$errText = 'merchant key mismatch';
    }
} else {
	$LMI_HASH=$_REQUEST["LMI_HASH"];
	$CalcHash = md5($LMI_PAYEE_PURSE.$LMI_PAYMENT_AMOUNT.$LMI_PAYMENT_NO.$LMI_MODE.$LMI_SYS_INVS_NO.$LMI_SYS_TRANS_NO.$LMI_SYS_TRANS_DATE.$merch_key.$LMI_PAYER_PURSE.$LMI_PAYER_WM);
	if($LMI_HASH != strtoupper($CalcHash)) {
	    $err = TRUE;
		$errText = 'hash mismatch';
    }
}



// TRACK USER POINTS PACKAGE SALE
$points_sale = app_UserPoints::getUserPointPackageSaleByHash($custom);

if ( $points_sale )
{
    app_UserPoints::logSale($custom, 'TIME: '.date("Y-m-d H:i:s", time())."; \n".print_r($_REQUEST, true), __FILE__, __LINE__);
    require_once 'uppc.php';
    exit();
}
// END of TRACK USER POINTS PACKAGE SALE


$saleInfo = app_Finance::GetSaleInfo($custom);
//echo '<pre>';
//print_r($points_sale);
//die();

if (empty($LMI_PAYMENT_NO) || empty($LMI_PAYEE_PURSE) ||  empty($LMI_PAYMENT_AMOUNT) ) {
	app_Finance::LogPayment( 'Parameter is missing', __FILE__, __LINE__, $custom );
    exit();
}


$amount = number_format($saleInfo['amount'], 2, '.', '');
if ($amount!=$LMI_PAYMENT_AMOUNT) {
    $err = TRUE;
	$errText = 'amount mismatch';
}


if($saleInfo['status']== 'approval' || $saleInfo['status']== 'error')  {die();}



if(!$err) {
    
    app_Finance::SetTransactionResult( $custom, 'approval', '', $LMI_PAYMENT_NO );
    app_Finance::LogPayment( 'APPROVAL', __FILE__, __LINE__ );
    $__CUSTOM = $custom;
    require_once( '../post_checkout.php' );
	app_Finance::LogPayment( 'END', __FILE__, __LINE__, $custom );
	exit('YES');
} else {
    app_Finance::SetTransactionResult( $custom, 'error' );
	app_Finance::LogPayment( $errText, __FILE__, __LINE__, $custom );
}